Loading...
Searching...
No Matches
juce::ARAPlaybackRegion Class Reference

## Detailed Description

Base class representing an ARA playback region.

The documentation for this class was generated from the following file:

- juce_audio_processors_headless/utilities/ARA/juce_ARAModelObjects.h

Inheritance diagram for juce::ARAPlaybackRegion:

## Public Types

enum class | IncludeHeadAndTail { no , yes }
| Used in getTimeRange to indicate whether the head and tail times should be included in the result. More...
using | PropertiesPtr = ARA::PlugIn::PropertiesPtr<ARA::ARAPlaybackRegionProperties>
using | Listener = ARAPlaybackRegionListener

## Public Member Functions

template<typename AudioModification_t = ARAAudioModification>
AudioModification_t * | getAudioModification () const noexcept
| Returns the result of ARA::PlugIn::PlaybackRegion::getAudioModification() with the pointer cast to ARAAudioModification*.
template<typename RegionSequence_t = ARARegionSequence>
RegionSequence_t * | getRegionSequence () const noexcept
| Returns the result of ARA::PlugIn::PlaybackRegion::getRegionSequence() with the pointer cast to ARARegionSequence*.
size_t | getNumChildren () const noexcept override
| Returns the number of ARA model objects aggregated by this object.
ARAObject * | getChild (size_t) override
| Returns the child object associated with the given index.
ARAObject * | getParent () override
| Returns the ARA model object that aggregates this object.
void | visit (ARAObjectVisitor &visitor) override
| Allows the retrieval of the concrete type of a model object.
Range< double > | getTimeRange (IncludeHeadAndTail includeHeadAndTail=IncludeHeadAndTail::no) const
| Returns the playback time range of this playback region.
Range< int64 > | getSampleRange (double sampleRate, IncludeHeadAndTail includeHeadAndTail=IncludeHeadAndTail::no) const
| Returns the playback sample range of this playback region.
double | getHeadTime () const
| Get the head length in seconds before the start of the region's playback time.
double | getTailTime () const
| Get the tail length in seconds after the end of the region's playback time.
void | notifyContentChanged (ARAContentUpdateScopes scopeFlags, bool notifyARAHost)
| Notify the ARA host and any listeners of a content update initiated by the plug-in.
Public Member Functions inherited from juce::ARAListenableModelClass< ARAPlaybackRegionListener >
| ARAListenableModelClass ()=default
| Constructor.
virtual | ~ARAListenableModelClass ()=default
| Destructor.
void | addListener (ARAPlaybackRegionListener *l)
| Subscribe `l` to notified by changes to the object.
void | removeListener (ARAPlaybackRegionListener *l)
| Unsubscribe `l` from object notifications.
void | notifyListeners (Callback &&callback)
| Call the provided callback for each of the added listeners.
Public Member Functions inherited from juce::ARAObject
virtual | ~ARAObject ()=default
| Destructor.
template<typename Fn>
void | traverse (Fn &&fn)
| Implements a depth first traversal of the ARA model graph starting from the current object, and visiting its children recursively.

## Member Typedef Documentation

## PropertiesPtr

using juce::ARAPlaybackRegion::PropertiesPtr = ARA::PlugIn::PropertiesPtr<ARA::ARAPlaybackRegionProperties>

## Listener

using juce::ARAPlaybackRegion::Listener = ARAPlaybackRegionListener

## Member Enums

## IncludeHeadAndTail

enum class juce::ARAPlaybackRegion::IncludeHeadAndTail

strong

Used in getTimeRange to indicate whether the head and tail times should be included in the result.

Enumerator
no |
yes |

## Member Functions

## getAudioModification()

template<typename AudioModification_t = ARAAudioModification>

AudioModification_t * juce::ARAPlaybackRegion::getAudioModification | ( |  | ) | const

inline noexcept

Returns the result of ARA::PlugIn::PlaybackRegion::getAudioModification() with the pointer cast to ARAAudioModification*.

If you have overridden ARADocumentControllerSpecialisation::doCreateAudioModification(), then you can use the template parameter to cast the pointers to your subclass of ARAAudioModification.

## getRegionSequence()

template<typename RegionSequence_t = ARARegionSequence>

RegionSequence_t * juce::ARAPlaybackRegion::getRegionSequence | ( |  | ) | const

inline noexcept

Returns the result of ARA::PlugIn::PlaybackRegion::getRegionSequence() with the pointer cast to ARARegionSequence*.

If you have overridden ARADocumentControllerSpecialisation::doCreateRegionSequence(), then you can use the template parameter to cast the pointers to your subclass of ARARegionSequence.

## getNumChildren()

size_t juce::ARAPlaybackRegion::getNumChildren | ( |  | ) | const

inline override virtual noexcept

Returns the number of ARA model objects aggregated by this object.

Objects that are merely referred to, but not aggregated by the current object are not included in this count, e.g. a referenced RegionSequence does not count as a child of the referring PlaybackRegion.

See the ARA documentation's ARA Model Graph Overview for more details.

Implements juce::ARAObject.

## getChild()

ARAObject * juce::ARAPlaybackRegion::getChild | ( | size_t | index | ) |

inline override virtual

Returns the child object associated with the given index.

The index should be smaller than the value returned by getNumChildren().

Note that the index of a particular object may change when the ARA model graph is edited.

Implements juce::ARAObject.

## getParent()

ARAObject * juce::ARAPlaybackRegion::getParent | ( |  | ) |

override virtual

Returns the ARA model object that aggregates this object.

Returns nullptr for the ARADocument root object.

Implements juce::ARAObject.

## visit()

void juce::ARAPlaybackRegion::visit | ( | ARAObjectVisitor & | visitor | ) |

inline override virtual

Allows the retrieval of the concrete type of a model object.

To use this, create a new class derived from ARAObjectVisitor and override its functions depending on which concrete types you are interested in.

Calling this function inside the function passed to ARAObject::traverse() allows you to map the entire ARA model graph.

Implements juce::ARAObject.

References juce::ARAObjectVisitor::visitPlaybackRegion().

## getTimeRange()

Range< double > juce::ARAPlaybackRegion::getTimeRange | ( | IncludeHeadAndTail | includeHeadAndTail = IncludeHeadAndTail::no | ) | const

Returns the playback time range of this playback region.

Parameters

  includeHeadAndTail | Whether or not the range includes the head and tail time of all playback regions in the sequence.

References no.

## getSampleRange()

Range< int64 > juce::ARAPlaybackRegion::getSampleRange | ( | double | sampleRate,
|  | IncludeHeadAndTail | includeHeadAndTail = IncludeHeadAndTail::no ) const

Returns the playback sample range of this playback region.

Parameters

  sampleRate | The rate at which the sample position should be calculated from the time range.
  includeHeadAndTail | Whether or not the range includes the head and tail time of all playback regions in the sequence.

References no.

## getHeadTime()

double juce::ARAPlaybackRegion::getHeadTime | ( |  | ) | const

Get the head length in seconds before the start of the region's playback time.

## getTailTime()

double juce::ARAPlaybackRegion::getTailTime | ( |  | ) | const

Get the tail length in seconds after the end of the region's playback time.

## notifyContentChanged()

void juce::ARAPlaybackRegion::notifyContentChanged | ( | ARAContentUpdateScopes | scopeFlags,
|  | bool | notifyARAHost )

Notify the ARA host and any listeners of a content update initiated by the plug-in.

This must be called by the plug-in model management code on the message thread whenever updating the internal content representation, such as after the user edited the pitch of a note in the underlying audio modification. Listeners will be notified immediately. If `notifyARAHost` is true, a notification to the host will be enqueued and sent out the next time it polls for updates.

Parameters

  scopeFlags | The scope of the content update.
  notifyARAHost | If true, the ARA host will be notified of the content change.

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited